﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace OneCollection2Views
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private List<Person> People;
        private ICollectionView AuthorsView;
        private ICollectionView CustomersView;
        private ICollectionView ExpertsView;

        public MainWindow()
        {
            InitializeComponent();

            People = new List<Person>();
            People.Add(new Person { Name = "John", IsAuthor = true });
            People.Add(new Person { Name = "Ann", IsAuthor = true });
            People.Add(new Person { Name = "Tom", IsAuthor = true });
            People.Add(new Person { Name = "Jeremy", IsAuthor = true });
            People.Add(new Person { Name = "Chris", IsAuthor = true });
           
            People.Add(new Person { Name = "Mike", IsCustomer = true });
            People.Add(new Person { Name = "Timothy", IsCustomer = true });
            People.Add(new Person { Name = "Mel", IsCustomer = true });
            People.Add(new Person { Name = "Andrew", IsCustomer = true });


            People.Add(new Person { Name = "Anthony", IsExpert = true });
            People.Add(new Person { Name = "Gerard", IsExpert = true });
            People.Add(new Person { Name = "Kyle", IsExpert = true });
            People.Add(new Person { Name = "Johny", IsExpert = true });
            People.Add(new Person { Name = "Peter", IsExpert = true });
            

            AuthorsView = new ListCollectionView(People);
            AuthorsView.Filter = (p) => { return (p as Person).IsAuthor; };

            CustomersView = new ListCollectionView(People);
            CustomersView.Filter = (p) => { return (p as Person).IsCustomer; };

            ExpertsView = new ListCollectionView(People);
            ExpertsView.Filter = (p) => { return (p as Person).IsExpert; };

            lvAll.ItemsSource = CollectionViewSource.GetDefaultView(People);
            lvAuthors.ItemsSource = AuthorsView;
            lvCustomers.ItemsSource = CustomersView;
            lvExperts.ItemsSource = ExpertsView;


            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            CustomersView.Refresh();
            ExpertsView.Refresh();
            AuthorsView.Refresh();
        }

        
    }


    public class Person
    {
        public string Name { get; set; }

        public bool IsAuthor { get; set; }

        public bool IsCustomer { get; set; }

        public bool IsExpert { get; set; }
    }
}
